unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ToolWin, Buttons, Hlabels, StdCtrls, MILFlashLabel, ExtCtrls,
  Grids, Math, LinePrnt, PagePrnt;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    rbtnMonthly: TRadioButton;
    rbtnWeekly: TRadioButton;
    Panel1: TPanel;
    flblCalculate: TMILFlashLabel;
    flblPrint: TMILFlashLabel;
    flblHelp: TMILFlashLabel;
    flblAbout: TMILFlashLabel;
    txtAmount: TEdit;
    txtInterest: TEdit;
    txtPayments: TEdit;
    Panel2: TPanel;
    grdAmort: TStringGrid;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    lblPayment: TLabel;
    lblInterest: TLabel;
    lblPrincipal: TLabel;
    flblExit: TMILFlashLabel;
    Image1: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label5: TLabel;
    lblTotalAmt: TLabel;
    PgPrint: TPagePrinter;
    procedure FillGrid;
    procedure FormCreate(Sender: TObject);
    procedure flblExitClick(Sender: TObject);
    procedure txtAmountKeyPress(Sender: TObject; var Key: Char);
    procedure txtInterestKeyPress(Sender: TObject; var Key: Char);
    procedure txtPaymentsKeyPress(Sender: TObject; var Key: Char);
    procedure txtAmountChange(Sender: TObject);
    procedure txtAmountEnter(Sender: TObject);
    procedure txtInterestEnter(Sender: TObject);
    procedure txtPaymentsEnter(Sender: TObject);
    procedure flblCalculateClick(Sender: TObject);
    procedure flblHelpClick(Sender: TObject);
    procedure flblAboutClick(Sender: TObject);
    procedure PgPrintNewPage(Sender: TObject);
    procedure PrintLoanDetail;
    procedure flblPrintClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  LoanAmt, PayAmt: currency;
  Interest: single;
  LoanLen: integer;
  strDate: string;
  aDays: array[1..12] of integer = (31,28,31,30,31,30,31,31,30,31,31,31);
  isNewPage: boolean;

implementation

uses Help, About;
{$R *.DFM}

function CheckNumber(t: TEdit): integer;
// Check to make sure a valid number is entered
var
   x: extended;
begin
     Result := 0;
     try
        x := strtofloat(t.Text);
     except
        on EConvertError do Result := 1;
     end;
end;

procedure CalcPayment;
// Calculate payment
begin
     PayAmt := Payment(Interest, LoanLen, -LoanAmt, 0.00, ptEndofPeriod);
end;

procedure TMainForm.FillGrid;
// Fill grid with values
var
   i: integer;
   int, prin, bal, totpay, totprin, totint: currency;
begin
     totpay := 0; totprin := 0; totint := 0;
     bal := LoanAmt;

     for i := 1 to LoanLen - 1 do
     begin
          // Interest
          int := (( bal * Interest + 0.005) * 100) / 100;
          grdAmort.Cells[3,i] := floattostrf(int, ffCurrency, 18, 2);
          // Principal
          prin := PayAmt - int;
          grdAmort.Cells[2,i] := floattostrf(prin, ffCurrency, 18, 2);
          // Calc remaining balance
          bal := bal - prin;
          grdAmort.Cells[4,i] := floattostrf(bal, ffCurrency, 18,2);
          // Update totals
          totpay := totpay + PayAmt;
          totprin := totprin + prin;
          totint := totint + int;
     end;
     // Handle last payment
     int := 0;
     prin := bal;
     with grdAmort do
     begin
          Cells[1,LoanLen] := floattostrf(bal, ffCurrency, 18, 2);
          Cells[2,LoanLen] := floattostrf(prin, ffCurrency, 18, 2);
          Cells[3,LoanLen] := floattostrf(int, ffCurrency, 18, 2);
          Cells[4,LoanLen] := ' $0.00';
          totpay := totpay + prin + int;
          totprin := totprin + prin;
          totint := totint + int;
     end;
     // Update total labels
     lblInterest.Caption := floattostrf(totint, ffCurrency, 18, 2);
     lblPrincipal.Caption := floattostrf(totprin, ffCurrency, 18, 2);
     lblTotalAmt.Caption := floattostrf(totpay, ffCurrency, 18, 2);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   n: integer;
begin
     isNewPage := false;
     {Set column widths}
     grdAmort.ColWidths[0] := 30;
     for n := 1 to 4 do
         grdAmort.ColWidths[n] := (grdAmort.Width - 40) div 4;

     {Set column headers}
     grdAmort.Cells[0,0] := '   #';
     grdAmort.Cells[1,0] := '      Payment';
     grdAmort.Cells[2,0] := '      Principal';
     grdAmort.Cells[3,0] := '      Interest';
     grdAmort.Cells[4,0] := '      Balance';

     {Default rows to 1}
     grdAmort.RowCount := 2;

end;

procedure TMainForm.flblExitClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.txtAmountKeyPress(Sender: TObject; var Key: Char);
begin
     if Key = chr(VK_RETURN) then
     begin
          Perform(WM_NEXTDLGCTL,0,0);
          Key := #0;
     end;
end;

procedure TMainForm.txtInterestKeyPress(Sender: TObject; var Key: Char);
begin
     if Key = chr(VK_RETURN) then
     begin
          Perform(WM_NEXTDLGCTL,0,0);
          Key := #0;
     end;
end;

procedure TMainForm.txtPaymentsKeyPress(Sender: TObject; var Key: Char);
begin
     if Key = chr(VK_RETURN) then
     begin
          txtAmount.SetFocus;
          Key := #0;
     end;
end;

procedure TMainForm.txtAmountChange(Sender: TObject);
var
   n: integer;
begin
     {Set some defaults for new entry}
     grdAmort.RowCount := 2;
     for n := 0 to 4 do
         grdAmort.Cells[n,1] := '';
     lblPayment.Caption := '0.00';
     lblInterest.Caption := '0.00';
     lblPrincipal.Caption := '0.00';
     lblTotalAmt.Caption := '0.00';
end;

procedure TMainForm.txtAmountEnter(Sender: TObject);
begin
     with txtAmount do
     begin
          SelStart := 0;
          SelLength := length(Text);
     end;
end;

procedure TMainForm.txtInterestEnter(Sender: TObject);
begin
     with txtInterest do
     begin
          SelStart := 0;
          SelLength := length(Text);
     end;
end;

procedure TMainForm.txtPaymentsEnter(Sender: TObject);
begin
     with txtPayments do
     begin
          SelStart := 0;
          SelLength := length(Text);
     end;
end;

procedure TMainForm.flblCalculateClick(Sender: TObject);
var
   x: extended;
   i: integer;
begin
     {Check for valid entries}
     if (txtAmount.Text = '') or (CheckNumber(txtAmount) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid loan amount. Please try again.   ');
          txtAmount.SetFocus;
          exit;
     end;
     if (txtInterest.Text = '') or (CheckNumber(txtInterest) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid interest amount. Please try again.   ');
          txtInterest.SetFocus;
          exit;
     end;
     if (txtPayments.Text = '') or (CheckNumber(txtPayments) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid payments entry. Please try again.   ');
          txtPayments.SetFocus;
          exit;
     end;
     {------------------Fill in variables----------------}
     // Loan Amount
     val(txtAmount.Text, x, i);
     LoanAmt := x;
     // Interest
     val(txtInterest.Text, x, i);
     Interest := x;
     if rbtnMonthly.Checked then
        Interest := (Interest / 100) / 12
     else
        Interest := (Interest / 100) / 52;
     // # of payments
     LoanLen := strtoint(txtPayments.Text);
     // Payment amount
     CalcPayment;
     lblPayment.Caption := floattostrf(PayAmt, ffCurrency, 18, 2);
     // Fill in grid
     grdAmort.Rowcount := LoanLen + 1;
     for i := 1 to LoanLen do
     begin
          grdAmort.Cells[0,i] := ' ' + inttostr(i);
          grdAmort.Cells[1,i] := floattostrf(PayAmt, ffCurrency, 18, 2);
     end;
     FillGrid;
end;

procedure TMainForm.flblHelpClick(Sender: TObject);
begin
     frmHelp.ShowModal;
end;

procedure TMainForm.flblAboutClick(Sender: TObject);
begin
     AboutBox.ShowModal;
end;

procedure TMainForm.PgPrintNewPage(Sender: TObject);
var
   s: string;
begin
     PgPrint.Font.Style := [fsBold];
     s := 'Loan Amount: ' + FloatToStrF(LoanAmt,ffCurrency,18,2);
     s := s + '   Interest: ' + txtInterest.Text + '% annually';
     s := s + '   Payments: ' + lblPayment.Caption;
     if rbtnWeekly.Checked then
        s := s + ' (weekly)'
     else
        s := s + ' (monthly)';
     PgPrint.WriteLine('');
     PgPrint.WriteLineAligned(taCenter,s);
     PgPrint.Font.Style := [];
     s := 'Due Date|Payment|Principal|Interest|Balance';
     with PgPrint do
     begin
          Font.Size := 9;
          WriteLine(' ');
          Font.Style := Font.Style + [fsItalic, fsUnderline];
          WriteTableLine(s);
          Font.Style := [];
          WriteLine(' ');
     end;
end;

procedure TMainForm.PrintLoanDetail;
var
   s: string;
begin
     PgPrint.WriteLine('');
     PgPrint.Font.Style := PgPrint.Font.Style + [fsBold];
     s := 'Totals|' + lblTotalAmt.Caption + '|';
     s := s + lblPrincipal.Caption + '|' + lblInterest.Caption + '| ';
     PgPrint.WriteTableLine(s);
end;

procedure TMainForm.flblPrintClick(Sender: TObject);
var
   temp, strDate: string;
   ok: boolean;
   StartDate: TDateTime;
   Month, Day, Year: word;
   i: integer;
begin
     {---------------------Check for valid entries--------------------}
     if (txtAmount.Text = '') or (CheckNumber(txtAmount) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid loan amount. Please try again.   ');
          txtAmount.SetFocus;
          exit;
     end;
     if (txtInterest.Text = '') or (CheckNumber(txtInterest) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid interest amount. Please try again.   ');
          txtInterest.SetFocus;
          exit;
     end;
     if (txtPayments.Text = '') or (CheckNumber(txtPayments) = 1) then
     begin
          MessageBeep(1);
          ShowMessage('   Invalid payments entry. Please try again.   ');
          txtPayments.SetFocus;
          exit;
     end;
     {---------------------------Calculated?---------------------------}
     if grdAmort.RowCount < 3 then flblCalculateClick(nil);

     {---------------------------Start Report--------------------------}
     ok := InputQuery('Starting Date','Enter payment starting date:',strDate);
     if (ok = false) or (strDate = '') then exit;
     try
        StartDate := StrToDate(strDate);
     except
        on EConvertError do
        begin
             ShowMessage(' Invalid starting date! Printing canceled.');
             exit;
        end;
     end;
     Application.ProcessMessages;
     strDate := FormatDateTime('mm/dd/yyyy', StartDate);
     DecodeDate(StartDate, Year, Month, Day);
     PgPrint.BeginDoc;
     for i := 1 to grdAmort.RowCount - 1 do
     begin
          temp := strDate + '|';
          temp := temp + grdAmort.Cells[1,i] + '|';
          temp := temp + grdAmort.Cells[2,i] + '|';
          temp := temp + grdAmort.Cells[3,i] + '|';
          temp := temp + grdAmort.Cells[4,i];
          PgPrint.WriteTableLine(temp);
          if rbtnWeekly.Checked then
             StartDate := StartDate + 7
          else
             StartDate := StartDate + aDays[Month];
          strDate := FormatDateTime('mm/dd/yyyy', StartDate);
          DecodeDate(StartDate, Year, Month, Day);
     end;
     PrintLoanDetail;
     PgPrint.EndDoc;
     PgPrint.Print;
end;

end.
